#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iostream>
#include <cassert>
#include <cstring>

#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define REP(i,n) FOR(i,0,n)

#define TRACE(x) cerr << #x << " = " << x << endl
#define _ << " _ " <<

#define pb push_back
#define X first
#define Y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int MAX = 15;

int p[MAX][MAX];
void stavi(int r1, int r2, int s1, int s2) {
  FOR(i, r1, r2+1) FOR(j, s1, s2+1) p[i][j] = 1;
}

int pr[4] = {1, 0, -1, 0};
int ps[4] = {0, 1, 0, -1};

int bio[MAX][MAX];
void dfs(int a, int b) {
  if (bio[a][b]++) return;  
  
  REP(i, 4) {
    int nr = a + pr[i];
    int ns = b + ps[i];
    if (p[nr][ns]) dfs(nr, ns);    
  }
}

int check(int x1, int y1, int x2, int y2) {
  memset(bio, 0, sizeof bio);
  dfs(x1, y1);
  return bio[x2][y2] > 0;  
}

int main(){
  ios_base::sync_with_stdio(false);

  int qq;
  scanf("%d", &qq);
 
  while(qq--) {
    int st;
    scanf("%d", &st);
    if (!st) {
      int x1, y1, x2, y2;
      scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
      stavi(x1, x2, y1, y2);
    }
    else {
      int x1, y1, x2, y2;
      scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
      printf("%d\n", check(x1, y1, x2, y2));
    }
  }  
  
  return 0;
}
